package at.bestsolution.rsd.rt.jpa;

import java.util.function.BiConsumer;
import java.util.function.BiFunction;
import java.util.function.Consumer;
import java.util.function.Function;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

@Deprecated
public abstract class BaseJPAHandler<N> {
	private final EntityManagerFactoryProvider entityManagerFactoryProvider;
	private final Function<EntityManager, N> namedQueryManagerFactory;
	
	private final EntityManagerProvider entityManagerProvider;

	public BaseJPAHandler(EntityManagerFactoryProvider entityManagerFactoryProvider, 
			Function<EntityManager, N> namedQueryManagerFactory) {
		this.entityManagerFactoryProvider = entityManagerFactoryProvider;
		this.entityManagerProvider = null;
		this.namedQueryManagerFactory = namedQueryManagerFactory;
	}
	
	public BaseJPAHandler(EntityManagerFactory entityManagerFactory, 
			Function<EntityManager, N> namedQueryManagerFactory) {
		this(new EntityManagerFactoryProvider() {
			
			@Override
			public EntityManagerFactory getEntityManagerFactory() {
				return entityManagerFactory;
			}
		}, namedQueryManagerFactory);
	}
	
	public BaseJPAHandler(EntityManagerProvider entityManagerProvider, Function<EntityManager, N> namedQueryManagerFactory) {
		this.entityManagerFactoryProvider = null;
		this.entityManagerProvider = entityManagerProvider;
		this.namedQueryManagerFactory = namedQueryManagerFactory;
	}
	
	public BaseJPAHandler(EntityManager entityManager, Function<EntityManager, N> namedQueryManagerFactory) {
		this(new EntityManagerProvider() {
			
			@Override
			public EntityManager getEntityManager() {
				return entityManager;
			}
		}, namedQueryManagerFactory);
	}

	protected final EntityManagerFactory getEntityManagerFactory() {
		return entityManagerFactoryProvider.getEntityManagerFactory();
	}
	
	protected final <T> T runWithEntityManager(Function<EntityManager, T> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				return f.apply(manager);
			} finally {
				manager.close();
			}			
		} else {
			return f.apply(entityManagerProvider.getEntityManager());
		}
	}
	
	protected final void runWithEntityManagerVoid(Consumer<EntityManager> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				f.accept(manager);
			} finally {
				manager.close();
			}	
		} else {
			f.accept(entityManagerProvider.getEntityManager());
		}
	}
	
	protected final <V> void runWithEntityManagerVoid(V v, BiConsumer<V,EntityManager> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				f.accept(v, manager);
			} finally {
				manager.close();
			}			
		} else {
			f.accept(v, entityManagerProvider.getEntityManager());
		}
	}
	
	protected final void runWithEntityManagerVoid(long v, LongConsumer f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				f.accept(v,manager);
			} finally {
				manager.close();
			}			
		} else {
			f.accept(v, entityManagerProvider.getEntityManager());
		}
	}
	
	protected final <V> void runWithEntityManagerVoid(long v, V v2, LongObjectConsumer<V> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				f.accept(v,v2,manager);
			} finally {
				manager.close();
			}			
		} else {
			f.accept(v, v2, entityManagerProvider.getEntityManager());
		}
	}
	
	protected final <U,V> void runWithEntityManagerVoid(U v, V v2, BiObjectConsumer<U,V> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				f.accept(v,v2,manager);
			} finally {
				manager.close();
			}			
		} else {
			f.accept(v, v2, entityManagerProvider.getEntityManager());
		}
	}
	
	protected final <T> T runNamedQuery(Function<N, T> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			try {
				return f.apply(namedQueryManagerFactory.apply(manager));
			} finally {
				manager.close();
			}			
		} else {
			return f.apply(namedQueryManagerFactory.apply(entityManagerProvider.getEntityManager()));
		}
	}
	
	protected final <T> T runWithBoth(BiFunction<EntityManager, N, T> f) {
		if( entityManagerFactoryProvider != null ) {
			EntityManager manager = getEntityManagerFactory().createEntityManager();
			N namedQuery = namedQueryManagerFactory.apply(manager);
			try {
				return f.apply(manager,namedQuery);
			} finally {
				manager.close();
			}			
		} else {
			EntityManager manager = entityManagerProvider.getEntityManager();
			N namedQuery = namedQueryManagerFactory.apply(manager);
			return f.apply(manager, namedQuery);
		}
	}
	
	public interface BiObjectConsumer<U,V> {
		public void accept(U u, V v, EntityManager e);
	}
	
	@FunctionalInterface
	public interface LongConsumer {
		public void accept(long value, EntityManager e);
	}
	
	@FunctionalInterface
	public interface LongObjectConsumer<T> {
		public void accept(long value, T object, EntityManager e);
	}
	
	
}
