package at.bestsolution.rsd.rt.jpa;

import java.util.HashMap;
import java.util.Map;
import java.util.function.BiFunction;
import java.util.function.Function;
import java.util.stream.Collectors;

import at.bestsolution.rsd.rt.util.LdapFilterSupport.BranchNode;
import at.bestsolution.rsd.rt.util.LdapFilterSupport.FilterNode;
import at.bestsolution.rsd.rt.util.LdapFilterSupport.LeafNode;
import at.bestsolution.rsd.rt.util.LdapFilterSupport.LeafNodeSubstring;
import at.bestsolution.rsd.rt.util.LdapFilterSupport.NodeType;

@Deprecated
public class JQLCriteriaSupport {
	public static class Criteria {
		public final String criteriaClause;
		public final Map<String, Object> values;

		public Criteria(String criteriaClause, Map<String, Object> values) {
			this.criteriaClause = criteriaClause;
			this.values = values;
		}
	}

	public static Criteria fromLdapExpression(FilterNode filter, Function<String, String> columnConverter,
			BiFunction<String, String, Object> valueConverter) {
		StringBuilder b = new StringBuilder();
		Map<String, Object> values = new HashMap<>();

		if (filter instanceof LeafNode) {
			append((LeafNode) filter, columnConverter, valueConverter, b, values, false);
		} else {
			append((BranchNode) filter, columnConverter, valueConverter, b, values);
		}

		return new Criteria(b.toString(), values);
	}

	private static void append(LeafNode node, Function<String, String> columnConverter,
			BiFunction<String, String, Object> valueConverter, StringBuilder b, Map<String, Object> values,
			boolean negate) {
		b.append(columnConverter.apply(node.attribute()));

		String valueKey = node.attribute();
		String currentKey = valueKey;
		int count = 1;

		while (values.containsKey(currentKey)) {
			currentKey = count + currentKey;
			count++;
		}

		if (node instanceof LeafNodeSubstring) {
			String value = ((LeafNodeSubstring) node).segments().stream().map(s -> s == null ? "%" : s)
					.collect(Collectors.joining());
			values.put(currentKey, valueConverter.apply(valueKey, value));
		} else {
			values.put(currentKey, valueConverter.apply(valueKey, node.value()));
		}

		switch (node.type()) {
		case APPROX:
		case EQUAL:
			if (negate) {
				b.append("!=");
			} else {
				b.append("=");
			}
			b.append(":");
			b.append(currentKey);
			break;
		case GREATER:
			if (negate) {
				b.append("<");
			} else {
				b.append(">=");
			}
			b.append(":");
			b.append(currentKey);
			break;
		case LESS:
			if (negate) {
				b.append(" > ");
			} else {
				b.append(" <= ");
			}
			b.append(":");
			b.append(currentKey);
			break;
		case PRESENT:
			if (negate) {
				b.append(" == null ");
			} else {
				b.append(" != null ");
			}
			b.append(":");
			b.append(currentKey);
		case SUBSTRING:
			if (negate) {
				b.append(" NOT LIKE ");
			} else {
				b.append(" LIKE ");
			}
			b.append(":");
			b.append(currentKey);
			break;
		default:
			break;
		}
	}

	private static void append(BranchNode node, Function<String, String> columnConverter,
			BiFunction<String, String, Object> valueConverter, StringBuilder b, Map<String, Object> values) {
		if (node.type() == NodeType.NOT) {
			if (node.children().size() == 1 && node.children().get(0) instanceof LeafNode) {
				append((LeafNode) node.children().get(0), columnConverter, valueConverter, b, values, true);
			} else {
				throw new IllegalStateException("We do not support NOT for groups");
			}
		}

		b.append("(");
		String conditionalOp = node.type() == NodeType.AND ? " AND " : " OR ";

		boolean flag = false;
		for (FilterNode filter : node.children()) {
			if( flag  ) {
				b.append(conditionalOp);
			}
			if (filter instanceof LeafNode) {
				append((LeafNode) filter, columnConverter, valueConverter, b, values, false);
			} else {
				append((BranchNode) filter, columnConverter, valueConverter, b, values);
			}
			flag = true;
		}

		b.append(")");
	}
}
